
package hello.jsp;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.DuplicateAttributeException;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableRootElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingAttributeException;
import javax.xml.bind.RootElement;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class MessageBean
    extends MarshallableRootElement
    implements RootElement
{

    private String _Time;
    private String _Host;
    private String _Message;

    public String getTime() {
        return _Time;
    }

    public void setTime(String _Time) {
        this._Time = _Time;
        if (_Time == null) {
            invalidate();
        }
    }

    public String getHost() {
        return _Host;
    }

    public void setHost(String _Host) {
        this._Host = _Host;
        if (_Host == null) {
            invalidate();
        }
    }

    public String getMessage() {
        return _Message;
    }

    public void setMessage(String _Message) {
        this._Message = _Message;
        if (_Message == null) {
            invalidate();
        }
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (_Time == null) {
            throw new MissingAttributeException("time");
        }
        if (_Host == null) {
            throw new MissingAttributeException("host");
        }
        if (_Message == null) {
            throw new MissingAttributeException("message");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("messageBean");
        w.attribute("time", _Time.toString());
        w.attribute("host", _Host.toString());
        w.attribute("message", _Message.toString());
        w.end("messageBean");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("messageBean");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            if (an.equals("time")) {
                if (_Time!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _Time = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("host")) {
                if (_Host!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _Host = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("message")) {
                if (_Message!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _Message = xs.takeAttributeValue();
                continue;
            }
            throw new InvalidAttributeException(an);
        }
        xs.takeEnd("messageBean");
    }

    public static MessageBean unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static MessageBean unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static MessageBean unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((MessageBean) d.unmarshal(xs, (MessageBean.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof MessageBean)) {
            return false;
        }
        MessageBean tob = ((MessageBean) ob);
        if (_Time!= null) {
            if (tob._Time == null) {
                return false;
            }
            if (!_Time.equals(tob._Time)) {
                return false;
            }
        } else {
            if (tob._Time!= null) {
                return false;
            }
        }
        if (_Host!= null) {
            if (tob._Host == null) {
                return false;
            }
            if (!_Host.equals(tob._Host)) {
                return false;
            }
        } else {
            if (tob._Host!= null) {
                return false;
            }
        }
        if (_Message!= null) {
            if (tob._Message == null) {
                return false;
            }
            if (!_Message.equals(tob._Message)) {
                return false;
            }
        } else {
            if (tob._Message!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((127 *h)+((_Time!= null)?_Time.hashCode(): 0));
        h = ((127 *h)+((_Host!= null)?_Host.hashCode(): 0));
        h = ((127 *h)+((_Message!= null)?_Message.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<messageBean");
        if (_Time!= null) {
            sb.append(" time=");
            sb.append(_Time.toString());
        }
        if (_Host!= null) {
            sb.append(" host=");
            sb.append(_Host.toString());
        }
        if (_Message!= null) {
            sb.append(" message=");
            sb.append(_Message.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        Dispatcher d = new Dispatcher();
        d.register("messageBean", (MessageBean.class));
        d.freezeElementNameMap();
        return d;
    }

}
